Subject: Re: CCL:Object-oriented means for computational chemistry programming

From: Konrad Hinsen <[email-masked]>
Date: Fri, 11 Jul 1997 15:56:37 +0200

> >- C is no more OO than Fortran, but it doesn't have most of Fortran's
> >  most severe problems. But Fortran-90 is no worse than C, and in some
> >  respects better.
> 
> i.e. Fortran can be OO too.

That's not what I wrote, and according to any accepted definition it's wrong.

> A quote by a distinguished scientist that I recall from a scientific
> meeting about 10 years ago:
> 
> "I don't know what type of programming language scientists will be using in
> the next millenium, but it will be CALLED Fortran"
> 
> i.e. Fortran will evolve over time to incorporate newly desired features 

Maybe. But will it be fast enough? Fortran-90 finally offered features
that have been around in other languages for 20 years. And Fortran-90
is far from generally accepted; you can't even expect every scientist
to have access to a Fortran-90 compiler yet.

> >Scientists should also have a closer look at high-level languages.
> >They make development and testing substantially easier by taking care
> >of much detail automatically. Of course that comes at a price in terms
> >of speed, but the majority of a typical scientific program is *not*
> >time-critical. The CPU intensive parts are specific subroutines that
> >can still be implemented in a low-level language.
> 
> e.g. a Visual Basic front-end with Fortran or C .DLL's

The world is larger than Windows! Visual Basic is a language available
on one operating system and from one vendor only. That doesn't make
sense for a community which jumps at the latest available supercomputers
as soon as they are available. Ever seen Visual Basic on a parallel
machine?

> No slight against Python, but we all remember the following historical
> sequence:
> 
> Algol  vs Fortran (1960's)
> PL1    vs Fortran (1970's)
> Pascal vs Fortran (1980's)
> 
> and now, it's
> 
> C      vs Fortran  
> 
> On the left-hand side, it has usually been CS (computer-science) types.  On
> the RH side, it has usually been scientists/engineers.

But the "left-hand side" has shown steady improvement, while the
right-hand side has merely stressed compatibility.

I am not saying that Fortran will disappear soon, but it will become
one among several languages used in science and engineering. There is
already a clear trend towards increased use of C and C++, which has
never happened with Algol or Pascal.

Instead of keeping up the battle between "CS types" and "scientists",
maybe it's time to start working together. The CS types have made
a lot of progress in software engineering during the last decades,
and scientists are about the only ones who seem to be determined to
ignore that.
-- 
-------------------------------------------------------------------------------
Konrad Hinsen                          | E-Mail: [email-masked]
Laboratoire de Dynamique Moleculaire   | Tel.: +33-4.76.88.99.28
Institut de Biologie Structurale       | Fax:  +33-4.76.88.54.94
41, av. des Martyrs                    | Deutsch/Esperanto/English/
38027 Grenoble Cedex 1, France         | Nederlands/Francais
-------------------------------------------------------------------------------

---

From: [email-masked] (Anthony J. Duben)
Date: Fri, 11 Jul 1997 09:06:45 -0500

RE: C/C++ vs. FORTRAN

IMHO there is another alternative -- Ada.  It is designed for writing solid
software engineering
 applications, lacks the arcana of C/C++, and has versions available for
most systems.

Tony Duben ([email-masked])
******************************************************
Anthony J. Duben
Associate Dean, College of Science and Technology
Mail Stop 6000
Southeast Missouri State University
1 University Plaza
Cape Girardeau MO 63701-4799
phone: 573-986-6036
fax: 573-651-2223
e-mail: [email-masked]

"Science is a wonderful thing if one does not have
 to earn a living at it."
          - Albert Einstein
*****************************************************